/**
 * Created by lyj on 2/9/15.
 */

define(function (require, exports, module) {
  module.exports = {
    init: function (clickEvent, closeEvent) {
      if ($(".ad-banner").length) {
        return false;
      }
      this.getData();
      this.bindEvent(clickEvent, closeEvent);
    },
    getData: function () {
      var that = this;
      xqBridge.request({
        url: "/advertise/banner/show.json",
        data: {
          type: 1
        },
        success: function (ret) {
          if (ret.image && !ret.closed) {
            that.render(ret);
          }
        }
      });
    },
    render: function (ret) {
      var html = ''
        + '<div class="ad-banner">'
        + '<img src="' + ret.image + '" data-url="' + ret.link + '" data-id="' + ret.id + '">'
        + '<div class="close-container">'
        + '<span class="ad-banner-close"></span>'
        + '</div>'
        + '</div>';

      var $ad = $(html);
      if ($(".markets").length) {
        $(".markets").css({
          top: "50px"
        })
          .next()
          .css({
            marginTop: '90px'
          });
        $ad.css({
          height: "50px",
          width: "100%",
          position: "fixed",
          display: "none",
          top: 0,
          zIndex: 5
        });
      } else {
        $ad.css({
          height: "50px",
          width: "100%",
          "margin-bottom": "10px",
          position: "relative",
          display: "none"
        });
      }


      $("#container").css({
        position: "relative",
        height: $(window).height()
      });

      $("body").prepend($ad);

      $ad.slideDown("fast");

      $(".ad-banner img").css({
        height: "50px",
        width: "100%"
      });

      $(".ad-banner-close").css({
        display: "inline-block",
        position: "absolute",
        left: "10px",
        top: "5px",
        width: "15px",
        height: "15px",
        "background-image": "url(./images/close_icon.png)",
        "background-size": "15px 15px",
        opacity: "0.2"
      });

      $(".close-container").css({
        width: "30px",
        height: "50px",
        position: "absolute",
        right: "0px",
        top: "0px"
      });
    },
    bindEvent: function (clickEvent, closeEvent) {
      $("body").on("click", ".close-container", function () {
        if (closeEvent && window.xqBridge) {
          xqBridge.trackEvent(closeEvent)
        }
        var banner_id = $(".ad-banner img").data("id");
        xqBridge.request({
          url: "/advertise/banner/close.json",
          type: "POST",
          data: {
            banner_id: banner_id
          },
          success: function (ret) {
            if (ret.success) {
              $(".ad-banner").hide();
              if ($(".markets").length) {
                $(".markets").css({
                  top: 0
                })
                  .next()
                  .css({
                    marginTop: '40px'
                  });
                ;
              }
            }
          }
        });
      });

      $("body").on("click", ".ad-banner img", function () {
        if (closeEvent && window.xqBridge) {
          xqBridge.trackEvent(clickEvent);
        }
        var url = $(this).data("url");

        xqBridge.redirect({
          type: "MODAL",
          url: url
        });
      });
    }
  };
});