/**
 * Created by lyj on 5/5/15.
 */
define(function (require, exports, module) {

  var stockListHtml = require('template/order/order-state-list.js');

  var params = Util.parseParams();
  var orders = params.orders ? $.parseJSON(decodeURIComponent(params.orders)):{};

  module.exports = {
    init: function (isSuccess) {
      if (!isSuccess) {
        var html = stockListHtml({
          data: {
            list: orders
          }
        });

        $(".order-state").html(html);
      } else {
        if (params.oid && $(".oid").length) {
          $(".oid").text(params.oid);
        } else {
          // 一键清仓 没有oid
          if (params.count || orders.length) {
            $(".state-desc p").html("感谢使用雪球实盘交易功能");
          }
        }
      }
      if(!!params.coupon){
        xqBridge.trackEvent("trade_order_quan");
        $(".state-desc").css({paddingBottom: 0});
        if (params.couponType.search("交易体验券") !== -1) {
          $(".coupon-text").text("委托单成交后，预计" + params.coupon + "元现金将返现到钱包余额");
        }
        if (params.couponType.search("亏损抵用券") !== -1) {
          $(".coupon-text").text("委托成交后，视收盘盈亏情况确定是否返现" + params.coupon + "元");
        }
        $(".coupon-success").show();
      }
      this.bindEvent();
    },
    bindEvent: function () {
      $(".state-desc").on("click", "a", function () {
        xqBridge.redirect({
          url: "/cube/order-state" + location.search,
          type: "PUSH"
        });

        return false;
      });

      $(".broker-order").on("click", function () {
        var url = "/broker/orders";
        if (params.tid) {
          url += "?tid=" + params.tid;
        }

        xqBridge.redirect({
          url: url,
          type: "PUSH"
        });
      });

      $(".back-cube").on("click", function () {
        xqBridge.redirect({
          type: "POP"
        });
      });

      $(".order-share").on("click", function () {
        var count = params.count || orders.length;
        var msg = "";
        if (count) {
          msg = "我通过雪球#一键清仓#卖出" + count + "只股票。股市无常，我想静静。";
        } else {
          var actionStr = params.action === "BUY" ? "买入" : "卖出";
          var stockStr = "$" + params.sname + "(" + params.symbol +  ")$";
          var price = params.price;

          if (params.tid === "IB") {
            price += "";
            var array = price.split(".");
            if (!array[1]) {
              price += ".00";
            } else {
              if (array[1].length == 1) {
                price += "0";
              }
            }
          }

          msg = "我刚刚在#雪球实盘交易#委托" + actionStr + stockStr + "，委托" + actionStr + "价" + price + "。";

          if (params.otype == "MKT") {
            msg = "我刚刚在#雪球实盘交易#市价委托" + actionStr + stockStr + "。";
          }
          if (params.newStock){
            msg = " 我刚刚在#雪球实盘交易#申购了新股" + stockStr + "，希望能中签~"
          }
        }

        xqBridge.confirm({
          title: "分享给球友",
          message: msg,
          success: function () {
            xqBridge.showLoading();

            var reqParams = {
              module_id: "yO51t0AH4X",
              status: msg
            };

            if (params.symbol) {
              reqParams.card_type = "stock";
              reqParams.card_param = params.symbol;
            }

            xqBridge.request({
              url: "/statuses/update.json",
              type: "POST",
              data: reqParams,
              success: function () {
                Util.showError("分享成功!");
                xqBridge.trackEvent("trade_orderShare");
              },
              error: function () {
                Util.showError("分享出错");
              },
              complete: function () {
                xqBridge.hideLoading();
              }
            });
          },
          cancel: function () {

          }
        });
      });
    }
  };
});