define(function (require, exports, module) {

  // 兼容老版本 因为老版本没有 open-list
  // 所以在跳转的时候 还是会跳到bind-list  在bind-list里面再做跳转
  var params = Util.parseParams();

  if (params && params.jump === "open") {
    window.location.href = "/broker/open-list";
  }

  var bindListTemplate = require('template/trade/config-broker-list.js');
  module.exports = {
    init: function () {
      var that = this;
      xqBridge.setRightNavigationButton({
        title: "开户",
        action: function () {
          xqBridge.trackEvent("secManage_open");
          xqBridge.trackSNBEvent({
            pageId: 31,
            widgetId: 2,
            widgetPosition: 1
          });
          xqBridge.redirect({
            url: '/broker/open-list?from=trademanage',
            type: "PUSH",
            success: function () {
              that.init();
            },
            cancel: function () {
              that.init();
            }
          })
        }
      });
      this.getData();
      if (!this.isBindEvent) {
        this.bindEvent();
      }
    },
    /**
     * 获取已绑定券商列表
     */
    getData: function () {
      var that = this;

      xqBridge.showLoading();
      var url = '/tc/snowx/securities/bound.json';
      //if (Util.appVersion() >= 7.2) {
      //  url = '/tc/snowx/securities/bound/v2.json ';
      //}
      xqBridge.request({
        url: url,
        success: function (ret) {
          if (ret.result_data && ret.result_data.length) {
            var brokers = ret.result_data.map(function (item) {
              if (item.status !== "SUCCESS") {
                item.trader_name += "(待添加)";
              }
              return item;
            });
            $(".brokers").html(bindListTemplate({
              data: {
                brokers: brokers
              }
            })).show();
          } else {
            $(".brokers").hide();
          }
        },
        error: function () {
          Util.showError("券商列表获取失败");
        },
        complete: function () {
          xqBridge.hideLoading();
        }
      })
    },
    bindEvent: function () {
      this.isBindEvent = true;
      Util.setPress(".broker-list li .top", "onpress");
      Util.setPress(".bind-open", "onpress");
      var that = this;

      $(".bind-open").on("click", function () {
        xqBridge.trackEvent("secManage_add");
        xqBridge.trackSNBEvent({
          pageId: 31,
          widgetId: 3,
          widgetPosition: 1
        });
        xqBridge.redirect({
          url: "/broker/bind-list",
          type: "MODAL",
          success: function () {
            if (Util.appVersion() >= 6.5) {
              xqBridge.updateBrokerList();
            }
            that.init();
          },
          cancel: function () {
            if (Util.appVersion() >= 6.5) {
              xqBridge.updateBrokerList();
            }
            that.init();
          }
        });
      });

      // 点击左边切换证券账户
      $(".brokers").on("click", "li .top .left", function () {
        xqBridge.trackEvent("secManage_switch");
        var tid = $(this).parent().data("tid");
        var aid = $(this).parent().data("aid");
        var status = $(this).parent().data("status");
        if (status !== "SUCCESS") {
          Util.showError("请完成添加后再设置默认");
          return false;
        }
        xqBridge.showLoading();
        xqBridge.request({
          url: "/tc/snowx/securities/default.json",
          type: "POST",
          data: {
            changetoaid: aid
          },
          success: function (ret) {
            if (ret.result_code == 60000) {
              if (Util.appVersion() >= 6.5) {
                xqBridge.updateBrokerList();
              }
              that.init();
            } else {
              xqBridge.hideLoading();
              Util.showError("切换账号出错");
            }
          },
          error: function () {
            xqBridge.hideLoading();
            Util.showError("切换账号出错");
          }
        });
      });

      // 点击右侧 删除
      $(".brokers").on("click", "li .top .right", function () {
        xqBridge.trackEvent("secManage_delete");
        var tid = $(this).parent().data("tid");
        var aid = $(this).parent().data("aid");
        var tname = $(this).parent().data("tname");
        var message = "删除后您将无法通过雪球直接下单进行证券交易。";
        xqBridge.trackSNBEvent({
          pageId: 31,
          widgetId: 4,
          widgetPosition: $(this).parent().parent().index()+1,
          foreignKey:tid || ''
        });
        xqBridge.confirm({
          title: "确认删除" + tname + "？",
          message: message,
          alignment: "left",
          success: function () {
            xqBridge.request({
              url: "/tc/snowx/unbind.json",
              type: "POST",
              data: {
                aid: aid,
                tid: tid
              },
              success: function (ret) {
                if (ret.result_code == 60000) {
                  if (Util.appVersion() >= 6.5) {
                    xqBridge.updateBrokerList();
                  }
                  that.init();
                } else {
                  Util.showError(ret.msg);
                }
              },
              error: function () {
                Util.showError("解绑失败！");
              },
              complete: function () {
              }
            });
          },
          cancel: function () {

          }
        });
      });
    }
  };
});
