/**
 * Created by victoryan on 15/9/23.
 */
(function () {
  "use strict";
  $(document).ready(function () {
    FastClick.attach(document.body);
    xqBridge.trackEvent("quan_PV");
    xqBridge.showLoading();
    var params = Util.parseParams();
    xqBridge.setRightNavigationButton({
      title: "使用规则",
      action: function () {
        xqBridge.redirect({
          url: 'http://xueqiu.com/broker/coupon/coupon-rules',
          type: "PUSH",
          success: function () {
          },
          cancel: function () {
          }
        })
      }
    });

    xqBridge.request({
      url: '/tc/snowx/reward/owner/query.json',
      success: function (data) {
        if (!data.result_data || data.result_data.length === 0) {
          $(".line,.coupon-count,.coupon-info").hide();
          $(".coupon-none").show();
        }
        if (data.result_code === '60000') {
          var couponList = data.result_data;
          if (params.type === "purchase") {
            couponList = couponList.filter(function (item) {
              return isCommission(item.type)
            })
          }
          // ACTIVE, LOCKED , USED, EXPIRED; 默认：ACTIVE
          var activeList = [];
          var usedList = [];
          var lockedList = [];
          var expiredList = [];
          couponList.map(function (item) {
            if (item.status === "ACTIVE") {
              activeList.push(item);
            } else if (item.status === "USED") {
              if (isLossDeduction(item.type)) {
                lockedList.push(item);
              } else {
                usedList.push(item);
              }
            } else if (item.status === "PAYED") {
              usedList.push(item);
            } else if (item.status === "LOCKED") {
              lockedList.push(item);
            } else if (item.status === "EXPIRED") {
              expiredList.push(item);
            }
            return item;
          });
          var sortCoupon = function (arr) {
            return arr.sort(function (a, b) {//排序
              var sortIndex = 0;
              var thisTime = moment(a.expiryDate).diff(moment(), 'days');
              var thatTime = moment(b.expiryDate).diff(moment(), 'days');
              if (thisTime > thatTime) {
                sortIndex = -1;
              } else {
                sortIndex = 1;
              }
              return sortIndex;
            });
          };
          //couponList = sortCoupon(activeList).concat(sortCoupon(lockedList)).concat(sortCoupon(usedList)).concat(sortCoupon(expiredList));
          couponList = sortCoupon(activeList);
          if (couponList.length === 0){
            $(".line,.coupon-count,.coupon-info").hide();
            $(".coupon-none").show();
            $('.more').show();
          }
          renderHtml(couponList);
          if (params.coupon) {
            $('.select,.coupon-select').show();
            if($('.checked').length !== 0){
              $(window).scrollTop($('.checked').offset().top - 30);
            }
            $('.container').css({paddingBottom: '70px'});
            $(".active").on('click', function () {
              var $this = $(this);
              if ($this.find('.select').hasClass('checked')) {
                $this.find('.select').removeClass('checked');
              } else {
                $('.select').removeClass('checked');
                $this.find('.select').addClass('checked');
              }
            });
            $('.coupon-select').on('click', function () {
              xqBridge.redirect({
                type: "CLOSE",
                successData: $('.checked').data('coupon') || 'none'
              })
            });
          } else {
            $(".active").on('click', function () {
              var $this = $(this),
                transferData = {};
              transferData.amount = $this.find('.detail-amount span').text();
              transferData.amountText = transferData.amount + "元";
              transferData.name = $this.find('.detail-title').text();
              transferData.expiration = $this.find('.time').text();
              transferData.type = $this.data('type');
              if (isLossDeduction(transferData.type)) {
                transferData.discreption = "出现亏损的买卖委托单补偿返现，限平安证券可用。收盘后如该笔委托出现浮亏（买单：收盘价低于买入价／卖单：收盘价高于卖出价），将按照券面额返还至雪球钱包余额。交易券每天限用3次。";
              } else {
                transferData.discreption = "平安证券实盘交易下单时自动提示使用，委托单成交后，券金额自动返还到雪球钱包余额。交易券每天限用3次。";
              }
              transferData.status = "有效";
              if ($this.find(".used").length !== 0) {
                transferData.status = "已使用";
              }
              if ($this.find(".overdue").length !== 0) {
                transferData.status = "已过期";
              }
              if ($this.find(".using").length !== 0) {
                transferData.status = "使用中";
              }
              xqBridge.redirect({
                url: "/broker/coupon/coupon-info?" + $.param(transferData),
                type: "PUSH"
              });
            });
          }
          $('.more').on('click',function(){
            $(".line,.coupon-count,.coupon-info").show();
            $(".coupon-none").hide();
            renderHtml(sortCoupon(lockedList).concat(sortCoupon(usedList)).concat(sortCoupon(expiredList)));
            $(this).hide();
          });
          $(".line").show();
          xqBridge.request({
            url: '/tc/snowx/reward/owner/remind/query.json',
            success: function (data) {
              var couponCount = 0;
              if (data.result_code === '60000') {
                if (data.result_data) {
                  couponCount = data.result_data.active_count;
                  $(".coupon-count").text(couponCount + "张可用交易券");
                }
              }
              //fix coupon count position
              var $couponCount = $(".coupon-count");
              fixPosition($couponCount);
              //$couponCount.css({marginLeft: "-" + parseFloat($couponCount.css('marginLeft').replace('-', '').replace('px', '')) - 20 + "px"});
            },
            error: function () {
              $(".coupon-count").text(0 + "张可用佣金券");
              var $couponCount = $(".coupon-count");
              fixPosition($couponCount);
              //$couponCount.css({marginLeft: "-" + parseFloat($couponCount.css('marginLeft').replace('-', '').replace('px', '')) - 20 + "px"});
            }
          });
        } else {
          if (data.length === 0) {
            $(".line,.coupon-count,.coupon-info").hide();
            $(".coupon-none").show();
          }
        }
        xqBridge.hideLoading();
      },
      error: function () {
        xqBridge.hideLoading();
        $(".line,.coupon-count,.coupon-info").hide();
        $(".coupon-none").show();
      }
    });
    function renderHtml(couponList) {
      couponList.map(function (item) {
        var templateArray = [];
        if (item.status === "ACTIVE" || item.status === "LOCKED") {
          if (isLossDeduction(item.type)){
            templateArray.push('<div class="coupon-list active"  style="background-image: url(http://assets.imedao.com/images/broker/coupon/coupon-bg-blue.png);">');
          }else{
            templateArray.push('<div class="coupon-list active">');
          }
          templateArray.push('<div class="top">');
        } else {
          templateArray.push('<div class="coupon-list" style="background-image: url(http://assets.imedao.com/images/broker/coupon/coupon-bg-gray.png);">');
          templateArray.push('<div class="top gray">');
        }
        if (isLossDeduction(item.type)){
          templateArray.push('<div class="detail-amount" style="color:#33AAFF"><i>￥</i><span>' + item.faceValue + '</span></div>');
          templateArray.push('<div class="detail-title"  style="color:#33AAFF">' + item.name + '</div></div>');
        }else{
          templateArray.push('<div class="detail-amount"><i>￥</i><span>' + item.faceValue + '</span></div>');
          templateArray.push('<div class="detail-title">' + item.name + '</div></div>');
        }
        templateArray.push('<div class="bottom"><div class="tip">' + item.label + '</div>');
        templateArray.push('<div class="time">有效期' + moment(item.startDate).format('YYYY/MM/DD') + '至' + moment(item.expiryDate).format('YYYY/MM/DD') + '</div>');
        if (item.status === "USED" || item.status === "PAYED") {
          templateArray.push('<div class="gone used"></div>');
        }
        if (item.status === "LOCKED") {
          templateArray.push('<div class="gone using"></div>');
        }
        if (item.status === "EXPIRED") {
          templateArray.push('<div class="gone overdue"></div>');
        }
        if (params.coupon) {
          if (params.coupon === item.rewardOwnerId) {
            templateArray.push('<div class="select checked" data-coupon="' + item.rewardOwnerId + '" data-type="' + item.type + '"></div>');
          } else {
            templateArray.push('<div class="select" data-coupon="' + item.rewardOwnerId + '" data-type="' + item.type + '"></div>');
          }
        }
        templateArray.push('</div></div>');
        var template = templateArray.join('');
        $('.coupon-info').append(template);
      });
      $('.more').show();
    }

    //fix position function
    function fixPosition($ele) {
      if ($ele && $ele.length && (typeof jQuery==="function" || typeof jQuery==="object") && $ele instanceof jQuery) {
        var width = $ele.width();
        var height = $ele.height();
        if ($ele.css('left') !== 'auto') {
          $ele.css({marginLeft: "-" + (width / 2 + 20) + "px"})
        }
        if ($ele.css('right') !== 'auto') {
          $ele.css({marginRight: "-" + width / 2 + "px"})
        }
        if ($ele.css('top') !== 'auto') {
          $ele.css({marginTop: "-" + height / 2 + "px"})
        }
        if ($ele.css('bottom') !== 'auto') {
          $ele.css({marginBottom: "-" + height / 2 + "px"})
        }
      } else {
        return;
      }
    }
    function isCommission(type) {
      return type.search("COMMISSION") !== -1;
    }

    function isLossDeduction(type) {
      return type.search("LOSS_DEDUCTION") !== -1;
    }
  });
})();

