/**
 * Created by flynngao on 15/2/8.
 */

define(function (require, exports, module) {
  xqBridge.trackEvent("trade-history");

  // 检查是否绑定
  var histoyListTemplate = require('template/trade/trade-history-list.js');
  var newStockTemplate = require('template/trade/new-stock-list.js');
  var urlParams = Util.parseParams();
  var aid = urlParams.aid;
  var tid = urlParams.tid;

  var isEnd = false;
  var isIPhone = navigator.userAgent.indexOf("iPhone") > -1;

  function errorHandler(e) {
    xqBridge.hideLoading();
    if (e && e.result_code == 60000) {
      return true;
    } else if (e && (e.result_code == 70005 || e.result_code == 70006)) {
      xqBridge.redirect({
        type: 'POP_CANCEL'
      });
    } else if (e && (e.error_description || e.msg)) {
      xqBridge.alert({
        message: e.msg || e.error_description,
        success: function () {
          xqBridge.redirect({
            type: 'POP_CANCEL'
          });
        }
      });
    } else {
      xqBridge.alert({
        message: '网络错误',
        success: function () {
          xqBridge.redirect({
            type: 'POP_CANCEL'
          });
        }
      });
    }
  }

  module.exports = {
    init: function () {
      xqBridge.showLoading();
      var end = moment(new Date().getTime());
      var start = moment(end._i).subtract(30, 'day');
      $('.start-date .main').text(start.format('MM.DD'));
      $('.start-date .year').text(start.format('YYYY'));
      $('.start-date').data('timestamp', start.format('x'));
      $('.end-date .main').text(end.format('MM.DD'));
      $('.end-date .year').text(end.format('YYYY'));
      $('.end-date').data('timestamp', end.format('x'));
      this.action = "today";
      if (urlParams && urlParams.action) {
        this.action = urlParams.action;
      }
      var that = this;
      var params = Util.parseParams();
      that.isIB = params.tid == "IB";
      if (params.tid === "PAMID") {
        $(".switch-type").removeClass("not-new-stock");
      }
      this.checkBind(function () {
        that.renderHtml();
        that.bindEvent();
      });

    },
    checkBind: function (cb) {
      var that = this;

      Util.checkAndInit({
        isIB: that.isIB,
        success: function (data) {

          if (!errorHandler(data)) {
            return;
          }

          var brokers = userInfo.brokerList;
          var broker = Util.getBroker(brokers, Util.parseParams().tid);

          aid = broker.aid;
          tid = broker.tid;
          cb();
        },

        // 初始化失败退出交易页面
        cancel: function () {
          xqBridge.redirect({
            type: "POP_CANCEL"
          });
        }
      });
    },
    renderHtml: function () {
      if (this.action === "today") {
        this.getTodayHistoryData(aid);
      } else {
        $("#trade-history").trigger("click");
        xqBridge.trackSNBEvent({
          pageId: 38,
          widgetId: 1,
          widgetPosition: 1
        });
      }

      if (!this.isIB) {
        $(".history-type").show();
        $(".history-list").css({
          "margin-top": "40px"
        });
      } else {
        this.showIbTip();
      }
      $(".dialog").css({
        marginTop: "-" + $(".dialog").height() / 2 + "px"
      });
    },
    getNewStockData: function (aid) {
      xqBridge.showLoading();
      var startTime = new Date().getMilliseconds();
      xqBridge.request({
        url: '/tc/snowx/newshare/list.json',
        type: "GET",
        data: {
          aid: aid,
          tid: tid
        },
        success: function (data) {
          if (data.result_data && Object.keys(data.result_data).length) {
            var stockData = [];
            _.each(data.result_data, function (value) {
              stockData.push(value);
            });
            stockData = stockData.sort(function (a, b) {
              if (a.onl_subbeg_date && b.onl_subbeg_date) {
                if (moment(a.onl_subbeg_date).diff(moment(b.onl_subbeg_date), 'days') > 0) {
                  return -1;
                } else {
                  return 1;
                }
              } else {
                return -1;
              }
            }).map(function (item) {
              if (item.status === "PURCHASE") {
                item["onl_subbeg_date_colored"] = true;
              } else if (item.status === "NUMBER") {
                item["onl_subbeg_date_colored"] = true;
                item["onl_distr_date_colored"] = true;
              } else if (item.status === "CONFIRM") {
                item["onl_subbeg_date_colored"] = true;
                item["onl_distr_date_colored"] = true;
                item["onl_lotwiner_stpub_date_colored"] = true;
                item["confirm_day_colored"] = true;
              } else {
                item["onl_subbeg_date_colored"] = true;
                item["onl_distr_date_colored"] = true;
                item["onl_lotwiner_stpub_date_colored"] = true;
              }
              ["onl_subbeg_date", "onl_distr_date", "onl_lotwiner_stpub_date", "pay_day", "confirm_day"].map(function (day) {
                if (item[day]) {
                  if (day === "onl_lotwiner_stpub_date") {
                    item.stpub_date = moment(item[day]).format("YYYY-MM-DD");
                  }
                  item[day] = moment(item[day]).format("MM-DD");
                } else {
                  item[day] = "--";
                }
              });
              //按照时间点亮
              //["onl_subbeg_date", "onl_distr_date", "onl_lotwiner_stpub_date", "pay_day", "confirm_day"].map(function (day) {
              //  if (item[day]) {
              //    moment(item[day]).diff(moment().format("YYYY-MM-DD"), 'days') <= 0 ? item[day + "_colored"] = true : item[day + "_colored"] = false;
              //    if (day === "onl_lotwiner_stpub_date") {
              //      item.stpub_date = moment(item[day]).format("YYYY-MM-DD");
              //    }
              //    item[day] = moment(item[day]).format("MM-DD");
              //  } else {
              //    item[day] = "--";
              //    item[day + "_colored"] = false;
              //  }
              //});
              return item;
            });
            $('.history-list').html(newStockTemplate({
              data: stockData
            }));
            $('.pay-in').on('click', function () {
              xqBridge.redirect({
                url: "/broker/transfer",
                type: "PUSH"
              })
            });
            $('.stock-head').on('click', function () {
              xqBridge.redirect({
                url: 'http://xueqiu.com/broker/new-stock-detail?' + $.param($(this).data('stock')),
                type: "PUSH"
              })
            })
          } else {
            $('.history-list').html(newStockTemplate());
          }
          $('.history-list').removeClass('fn-hide');
        },
        error: function (err) {
          $('.history-list').html(newStockTemplate());
          Util.toast.show("请求数据失败");
        },
        complete: function () {
          xqBridge.hideLoading();
          //console.log(new Date().getMilliseconds() - startTime);
        }
      });
    },
    getTodayHistoryData: function (aid) {
      var that = this;
      xqBridge.showLoading();
      // 请求今天历史
      xqBridge.request({
        url: '/tc/snowx/transaction/list.json',
        data: {
          aid: aid,
          tid: tid
        },
        success: function (historyList) {
          if (historyList.result_code === "60000") {
            historyList.result_data = historyList.result_data.map(function (item) {
              item.camount = Math.abs(item.camount);
              var symbol = item.etype.substr(0, 2) + item.scode;
              item.commission = Util.getCommission(item.cprice, item.camount, item.action, symbol, Util.parseParams().tid).calculateAmount;
              return item;
            });
            $('.history-list').html(histoyListTemplate({
              data: {
                histories: historyList.result_data,
                action: 'today',
                isIB: that.isIB
              }
            }));
            if (that.isIB) {
              $(".notIb").hide();
              $(".isIb").show();
            } else {
              $(".notIb").show();
              $(".isIb").hide();
            }
            //手续费参考
            $(".question-mark").on('click', function (e) {
              e.preventDefault();
              xqBridge.trackEvent("trade_history_fee");
              $(".dialog").fadeIn();
              that.overlay.showOverlay();
            });
            $("#close-dialog").on('click', function (e) {
              e.preventDefault();
              that.overlay.hideOverlay();
              $(".dialog").hide();
            });
            $('.history-list').removeClass('fn-hide');
          } else {
            $('.history-list').html(histoyListTemplate({
              data: {
                histories: [],
                action: 'history'
              }
            }));
            $('.history-list').removeClass('fn-hide');
            Util.toast.show(historyList.msg);
          }
          $("th.date").html("时间");
        },
        error: function (e) {
          Util.showError(e.error_description || e.msg);
        },
        complete: function () {
          xqBridge.hideLoading();
        }
      });

    },
    getHistoryData: function (aid, pos, start, end) {
      var that = this;
      xqBridge.showLoading();
      // 请求历史交易
      xqBridge.request({
        url: '/tc/snowx/transaction/list_history.json',
        data: {
          aid: aid,
          tid: tid,
          pos: pos,
          start: start,
          end: end
        },
        success: function (historyList) {
          if (historyList.result_code === "60000") {
            var oidList = [];
            historyList.result_data = historyList.result_data.map(function (item) {
              item.camount = Math.abs(item.camount);
              var symbol = item.etype.substr(0, 2) + item.scode;
              if (_.findIndex(oidList, item.oid) === -1) {
                item.commission = Util.getCommission(item.cprice, item.camount, item.action, symbol).calculateAmount;
              } else {
                item.commission = "0.00";
              }
              oidList.push(item.oid);
              return item;
            });
            if (pos) {
              if (historyList.result_data && historyList.result_data.length === 0) {
                isEnd = true;
              }
              $('.history-list .update-history').replaceWith(histoyListTemplate({
                data: {
                  histories: historyList.result_data,
                  action: 'history-append'
                }
              }));
              if (that.isIB) {
                $(".notIb").hide();
                $(".isIb").show();
              } else {
                $(".notIb").show();
                $(".isIb").hide();
              }
              $('.history-list').removeClass('fn-hide');
            } else {
              isEnd = false;
              $('.history-list').html(histoyListTemplate({
                data: {
                  histories: historyList.result_data,
                  action: 'history'
                }
              }));
              if (that.isIB) {
                $(".notIb").hide();
                $(".isIb").show();
              } else {
                $(".notIb").show();
                $(".isIb").hide();
              }
              $('.history-list').removeClass('fn-hide');
            }
            //手续费参考
            $(".question-mark").on('click', function (e) {
              e.preventDefault();
              xqBridge.trackEvent("trade_history_fee");
              $(".dialog").fadeIn("fast");
              that.overlay.showOverlay();
            });
            $("#close-dialog").on('click', function (e) {
              e.preventDefault();
              that.overlay.hideOverlay();
              $(".dialog").hide("fast");
            });
          } else {
            $('.history-list').html(histoyListTemplate({
              data: {
                histories: [],
                action: 'history'
              }
            }))
            $('.history-list').removeClass('fn-hide');
            Util.toast.show(historyList.msg);
          }
          $("th.date").html("日期");
        },
        error: function (e) {
          $('.history-list').html(histoyListTemplate({
            data: {
              histories: [],
              action: 'history'
            }
          }))
          $('.history-list').removeClass('fn-hide');
        },
        complete: function () {
          xqBridge.hideLoading();
        }
      });
    },
    showIbTip: function () {
      var hours = moment().hour();
      var tip = "";
      if (moment().minute() > 0) {
        hours++;
      }
      if (hours >= 20) {
        tip = "交易记录时间：" + moment().format("M月DD日") + "20:00-" + moment().add(1, "days").format("M月DD日") + "20:00(北京)";
      } else {
        tip = "交易记录时间：" + moment().subtract(1, "days").format("M月DD日") + "20:00-" + moment().format("M月DD日") + "20:00(北京)";
      }
      $(".tip").text(tip);
    },
    overlay: {
      showOverlay: function () {
        var docHeight = $(document).height();
        if ($("#overlay").length) {
          $("#overlay").fadeIn("fast");
        } else {
          $("body").append("<div id='overlay'></div>");
          $("#overlay")
          //.height(docHeight)
            .css({
              'height': '100%',
              'opacity': 0.4,
              'position': 'absolute',
              'top': 0,
              'left': 0,
              'background-color': 'black',
              'width': '100%',
              'z-index': 400,
              'display': 'none'
            })
            .fadeIn("fast")
            .on('touchstart', function () {
              $(this).fadeOut("fast");
              $(".dialog").fadeOut("fast");
            })

        }
      },
      hideOverlay: function () {
        if ($("#overlay").length) {
          $("#overlay").remove()
        }
      }
    },
    bindEvent: function () {
      var that = this;

      // 领取奖励
      $("body").on("click", "button.enable", function () {
        var $td = $(this).parent(),
          $button = $(this),
          ctime = $td.data("time"),
          oid = $td.data("oid");

        var appVersion = Util.appVersion();

        if (appVersion < 6) {
          Util.showError("客户端版本过低，请先升级客户端。");
          return false;
        }

        if ($button.data("disabled")) {
          return false;
        }

        $button.data("disabled", true);
        xqBridge.showLoading();

        xqBridge.request({
          url: "/tc/snowx/ad/lucky.json",
          type: "POST",
          data: {
            aid: aid,
            oid: (ctime + "").substr(0, 8) + "-" + oid
          },
          success: function (ret) {
            if (ret.result_code == 60000) {
              ctime += "";
              var timeStr = ctime.substr(8, 2) + ":" + ctime.substr(10, 2);
              if (that.action === "history") {
                timeStr = ctime.substr(4, 2) + "." + ctime.substr(6, 2);
              }

              $td.html(timeStr).addClass("date");
              xqBridge.redirect({
                url: "/broker/lucky-result?" + $.param(ret.result_data),
                type: "PUSH"
              });
            } else {
              Util.showError(ret.msg);
            }
          },
          error: function () {
            Util.showError("服务出错，请重新尝试");
          },
          complete: function () {
            xqBridge.hideLoading();
            $button.data("disabled", false)
          }
        });
      });

      $('body').on('click', '.history-type button', function (e) {
        if (!$(this).find('span').hasClass('select')) {
          $('.history-type button').find('span').removeClass('select');
          $(this).find('span').addClass('select');
          $('.history-list').addClass('fn-hide');
          if ($(this).attr('id') == 'today-history') {
            $('.history-list').css({
              'margin-top': '40px'
            });
            $('.history-date').addClass('fn-hide');
            $('th.date').text('时间');
            that.action = "today";
            that.getTodayHistoryData(aid);
            xqBridge.trackSNBEvent({
              pageId: 38,
              widgetId: 5,
              widgetPosition: 1
            });
          } else if ($(this).attr('id') == 'trade-history') {
            xqBridge.trackEvent("conclude_history");
            xqBridge.trackSNBEvent({
              pageId: 38,
              widgetId: 2,
              widgetPosition: 1
            });
            var start = $('.start-date').data('timestamp');
            var end = $('.end-date').data('timestamp');
            $('.history-list').css({
              'margin-top': '150px'
            });
            $('.history-date').removeClass('fn-hide');
            var date = $('.history-date').data('moment');
            $('th.date').text('日期');
            that.action = "history";
            that.getHistoryData(aid, '', start, end);
          } else {
            $('.history-list').css({
              'margin-top': '49px'
            });
            $('.history-date').addClass('fn-hide');
            that.action = "newStock";
            that.getNewStockData(aid);
          }
        }
      });

      $('body').on('click', '.select-date', function (e) {
        var d = this;
        var date = $(d).data('timestamp');
        if ($(d).hasClass('start-date')) {
          xqBridge.trackSNBEvent({
            pageId: 38,
            widgetId: 3,
            widgetPosition: 1
          });
        } else {
          xqBridge.trackSNBEvent({
            pageId: 38,
            widgetId: 4,
            widgetPosition: 1
          });
        }
        if (!$(this).hasClass('date-opened')) {
          $('.select-date').addClass('date-opened');
          xqBridge.datePicker({
            date: date,
            success: function (date) {
              date = parseInt(date);
              $(d).find('.main').text(moment(date).format('MM.DD'));
              $(d).find('.year').text(moment(date).format('YYYY'));
              $(d).data('timestamp', date);
              if ($(d).hasClass('start-date') && date > $('.end-date').data('timestamp')) {
                $('.end-date').find('.main').text(moment(date).add(30, 'day').format('MM.DD'));
                $('.end-date').find('.year').text(moment(date).add(30, 'day').format('YYYY'));
                $('.end-date').data('timestamp', moment(date).add(30, 'day').format('x'));
              } else if ($(d).hasClass('end-date') && date < $('.start-date').data('timestamp')) {
                $('.start-date').find('.main').text(moment(date).subtract(30, 'day').format('MM.DD'));
                $('.start-date').find('.year').text(moment(date).subtract(30, 'day').format('YYYY'));
                $('.start-date').data('timestamp', moment(date).subtract(30, 'day').format('x'));
              }
              var start = $('.start-date').data('timestamp');
              var end = $('.end-date').data('timestamp');
              $('.select-date').removeClass('date-opened')
              that.getHistoryData(aid, "", start, end);
            },
            cancel: function () {
              $('.select-date').removeClass('date-opened')
            }
          })

        }
      });

      //页面滚动刷新
      var timer = 0;
      $(window).on('scroll', function () {
        timer && clearTimeout(timer);
        timer = setTimeout(function () {
          var winScrollTop = window.scrollY;
          var winHeight = window.innerHeight;
          var docOffsetHeight = document.body.offsetHeight;
          if (winScrollTop + winHeight > docOffsetHeight - winHeight * 0.1 && !isEnd && that.action === "history") {
            var start = $('.start-date').data('timestamp');
            var end = $('.end-date').data('timestamp');
            var position = $('tbody tr[data-pos]:last').data('pos');
            that.getHistoryData(aid, position, start, end);
          }
        }, 60);
      });
    }
  }
});
