$(function () {
  /**
   * 渲染钱包cell
   * @param  {[asset]}
   * @return {[string]}
   */
  function rendeAasset(asset) {
    var html = "";
    html += ''
    + '<li data-cellid="' + asset.id + '" data-bindurl="' + asset.url + '">'
    + '<div class="pic">'
    + '<img src="' + asset.image_url + '">'
    + '</div>'
    + '<div class="content">'
    + '<div class="name">' + asset.name + '</div>'
    + '<div class="desc">' + asset.desc + '</div>'
    + '</div>'
    + '<img src="images/arrow.png">'
    + '<div class="content-detail">'
    + '<a class="amount">' + asset.detail + '<span>' + asset.unit + '</span></a>'
    + '</div>' +
    '</li>'
    return html;
  }

  /**
   * 渲染钱包列表
   * @param  assets
   */
  function renderAssetList(assets) {
    var asssetContent = {
      "snow_money": {
        "id": "snow_money",
        "name": "余额",
        "url": "/wallet/balance",
        "desc": "",
        "detail": "",
        "unit": "元",
        "image_url": "images/icon_wallet_balance@2x.png"
      },
      "snow_coin": {
        "id": "snow_coin",
        "name": "雪球币",
        "url": "http://xueqiu.com/wallet/snow-coin",
        "desc": "",
        "detail": "",
        "unit": "雪球币",
        "image_url": "images/icon_wallet_snowcoin@2x.png"
      }
      //,
      //"coupon": {
      //  "id": "coupon",
      //  "name": "交易券",
      //  "url": "/broker/coupon-list",
      //  "desc": "",
      //  "detail": "",
      //  "unit": "张可用",
      //  "image_url": "images/icon_wallet_coupon@2x.png"
      //}
    };

    var assetsHtml = "";
    $.each(asssetContent, function (key) {
      var content = asssetContent[key];
      content['detail'] = assets[key];
      if (key == 'snow_money') {
        content.detail = parseFloat(content.detail/100).toFixed(2);
      }
      assetsHtml += rendeAasset(content);
    });
    $(".assets-list").html(assetsHtml);
    $(".assets-list li").each(function () {
      if ($(this).find('.desc').text() == "") {
        $(this).find('.name').css("padding-top", "8px");
      }
    });
    $(".assets").css('display', 'block');
  }

  var toast = {
    show: function (message) {
      "use strict";
      var $toast = $(".toast");
      if ($toast.length > 0) {
        $toast.show();
        setTimeout(function () {
          $toast.hide();
        }, 3000);
      } else {
        $toast = $("<div class='toast'>" + message + "</div>");
        $("body").append($toast);
        $toast.css({
          backgroundColor: "rgba(0,0,0,0.6)",
          fontSize: "12px",
          borderRadius: '5px',
          position: "fixed",
          bottom: "15%",
          left: "15%",
          color: "#fff",
          padding: "10px",
          display: "none",
          zIndex: "9999",
          textAlign: "center",
          width: "70%",
          marginLeft: '-10px'
        });
        $toast.show();
        setTimeout(function () {
          $toast.hide();
        }, 3000);
      }
    },
    hide: function () {
      "use strict";
      if ($(".toast").length > 0) {
        $(".toast").hide();
      }
    }
  };
  function getAccetsList() {
    xqBridge.request({
      url: "/tc/snowpay/wallet/merge.json",
      type: "GET",
      data: {},
      success: function (ret) {
        if (ret) {
          ret.coupon = 0;
          xqBridge.request({
            url: '/tc/snowx/reward/owner/remind/query.json',
            success: function (data) {
              var couponCount = 0;
              if (data.result_code === '60000') {
                if (data.result_data) {
                  ret.coupon = data.result_data.active_count;
                }
              }
              if (ret.coupon) {
                delete ret.coupon;
              }
              renderAssetList(ret);
            },
            error:function(){
              renderAssetList(ret);
            }
          });
        }
      },
      error: function (xhr) {
        toast.show('获取数据出错');
      },
      complete: function () {
        /*  */
      }
    });
  }

  getAccetsList();
  window.viewDidAppear = function(){
    getAccetsList();
  };

  $(".assets-list").on("click", "li", function () {
    var bindUrl = $(this).data("bindurl");
    xqBridge.redirect({
      url: bindUrl,
      type: "PUSH"
    });
    return false;
  });
});