/**
 * Created by natefang on 3/11/15.
 */
define(function (require, exports, module) {

    var balanceInfo = require('template/balance/balance-content.js');

    module.exports = {
      init: function (){
        var that = this
        that.setNavigationButton()
        that.getBalanceInfo()
      },
      setNavigationButton: function(){
        xqBridge.setRightNavigationButton({
          title: "收支明细",
          action: function () {
            var bindUrl = "/wallet/bill";
            xqBridge.redirect({
              url: bindUrl,
              type: "PUSH"
            });
          }
        });
      },
      getBalanceInfo: function(){
        var that = this;
        xqBridge.showLoading();
        xqBridge.request({
          url: "/tc/snowpay/wallet/show.json",
          type: "GET",
          success: function (ret) {
            xqBridge.hideLoading()
            var balance = balanceInfo({
              data: {
                balanceInfo: ret,
                balance: moneyString(((ret.snow_money + ret.snow_money_in) / 100).toString()),
                snow_money_in: moneyString((ret.snow_money_in / 100).toString()),
                snow_money: moneyString((ret.snow_money / 100).toString())
              }
            });
            $('#container').html(balance)
            $('body').data('snow_money', ret.snow_money)
            $('body').data('snow_money_in', ret.snow_money_in)
            that.bindEvent()
          },
          error: function (e) {
            xqBridge.hideLoading();
            xqBridge.error('获取数据出错');
          }
        })
      },
      bindEvent: function(){
        var that = this

        if (that.isBindEvent) {
          return;
        }
        that.isBindEvent = true;

        //window.viewDidAppear = function () {
        //  that.getBalanceInfo()
        //}

        Util.setPress("button", "active")
        $("button").on("click", function (e) {
          e.preventDefault();
          if(!$('button').hasClass('disable')){
            $("button").addClass('disable')

            if ($('body').data('snow_money') === 0){
              xqBridge.alert({
                message:"可用余额为0，还不能提现哦！"
              })
              $("button").removeClass('disable');
              return
            }

            xqBridge.request({
              url: "/account/telephone.json",
              type: "GET",
              success: function (ret) {
                $("button").removeClass('disable');
                if (ret.number) {
                  xqBridge.redirect({
                    url: '/wallet/withdraw-cash?number=' + ret.number
                    + '&areaCode=' + ret.areaCode
                    + '&snow_money=' + $('body').data('snow_money'),
                    type: "PUSH"
                  });
                } else {
                  xqBridge.verifyTelephone({
                    type: "bind",
                    success: function (num) {
                      xqBridge.redirect({
                        url: '/wallet/withdraw-cash?number=' + num
                        + '&areaCode=' + ret.areaCode
                        + '&snow_money=' + $('body').data('snow_money'),
                        type: "PUSH"
                      });
                    }
                  })
                }
              },
              error: function (e) {
                $("button").removeClass('disable');
                Util.showError(e.error_description);
              }
            })
          }
        })
        $('body').on('click','.footer',function(e){
          e.preventDefault();
          xqBridge.redirect({
            url: "/wallet/balanceQndA",
            type: "PUSH"
          });
        });
      }
    }

    function moneyString(s) {
      if (/[^0-9\.]/.test(s)) return "invalid value";
      s = s.replace(/^(\d*)$/, "$1.");
      s = (s + "00").replace(/(\d*\.\d\d)\d*/, "$1");
      s = s.replace(".", ",");
      var re = /(\d)(\d{3},)/;
      while (re.test(s))
        s = s.replace(re, "$1,$2");
      s = s.replace(/,(\d\d)$/, ".$1");
      return s.replace(/^\./, "0.")
    }
})


