$(function () {

  var pageNo = 0;
  var hasMore = true;
  var dataMap = {};

  function renderBillItem(bill) {
    var createdAt = moment(parseInt(bill.created_at)).format("YYYY-MM-DD HH:mm");
    var amount = (bill.snow_money/100).formatMoney(2, '.', ',');

    var amount = parseFloat((bill.snow_money - bill.pre_snow_money)/100);
    var amountFormat = (amount).formatMoney(2, '.', ',');
    var amountHtml;
    if (amount > 0) {
      amountHtml = '<div class="amount-positive">+' + amountFormat + '</div>';
    } else {
      amountHtml = '<div class="amount-negative">' + amountFormat + '</div>';
    }

    var htmlString = ''
      + '<li data-id="' + bill.id + '">'
      + '<div class="arrow-left">'
      + '<p class="bill-name">' + bill.name + '</p>'
      + '<p class="bill-createdAt">' + createdAt + '</p>'
      + '</div>'
      + amountHtml
      + '</div>'
    '</li>'

    return htmlString;
  }

  /**
   * 渲染钱包列表
   * @param  assets
   */
  function renderBillList(result) {
    var billList = result['list'];
    var listHtml = "";

    if (billList.length == 0) {
      if (pageNo == 1) {
        $(".no-data").hide().show();
      }
      return;
    }

    _.each(billList, function (b) {
      listHtml += renderBillItem(b);
      dataMap[b.id] = b;
    });

    $(".bill-list").append(listHtml);

    if (pageNo >= result['maxPage']) {  // if is the last page data
      hasMore = false;
      $(".loading").hide();
    } else if (pageNo == 1) {
      $(".loading").show();
    }
  }

  function getBillList() {
   pageNo++;
    xqBridge.request({
      url: "/tc/snowpay/bill/list.json",
      type: "GET",
      data: {
        page: pageNo,
        count: 20
      },
      success: function (ret) {
        if (ret) {
          renderBillList(ret);
        }
      },
      error: function (e) {
        Util.showError(e.error_description);
      },
      complete: function () {
      }
    });
    //renderBillList(getTestData(pageNo, 20));
  }

  function getTestData(page, count) {

    var result = {
      "count": 20,
      "maxPage": 6,
      "page": 1,
      "totalCount": 120
    }
    result.list = [];

    if (page > result.maxPage) {
      return result;
    }

    for (var i = 0; i < count; i++) {
      result.list[i] = {
        "id": i * pageNo,
        "bill_no": 5981637035561820000,
        "billType": "remain",
        "trade_no": 5981637035561820000,
        "tradeType": "comsume",
        "userId": 3808810544,
        "name": "购买组合page=" + pageNo + "item=" + i,
        "comment": "使用了礼券200",
        "amount": 200 + i,
        "pre_snow_money": 400.01,
        "snow_money": 200.01,
        "created_at": 1426150258009
      };
    }
    return result;
  }

  $(".bill-list").on("click", "li", function () {
    var id = $(this).data("id");
    var item = dataMap[id];
    xqBridge.redirect({
      url: "/wallet/bill-detail?" + $.param(item),
      type: "PUSH"
    });
    return false;
  });

  $(window).bind('scroll', function () {
    show()
  });

  function show() {
    if ($(window).scrollTop() + $(window).height() >= $(document).height()) {
      if (hasMore) {
        getBillList();
      }
    }
  };

  getBillList();

});