define(function (require, exports, module){
  var pageNo = 1;
  var maxPage;

  module.exports = {
    init: function () {
      var that = this;
      that.showMore();

      $(window).bind('scroll', function () {
        that.loadMore()
      });
    },
    randerItem: function (bill) {
      var createdAt = moment(parseInt(bill.created_at)).format("YYYY-MM-DD HH:mm");
      var amount = parseFloat((bill.snow_coin));
      var amountFormat = (amount).formatMoney(2, '.', ',');
      var amountHtml;
      if (amount > 0) {
        amountHtml = '<div class="amount-positive">+' + amountFormat + '</div>';
      } else {
        amountHtml = '<div class="amount-negative">' + amountFormat + '</div>';
      }

      var htmlString = ''
        + '<li data-id="' + bill.id + '">'
        + '<div class="arrow-left">'
        + '<p class="bill-name">' + bill.name + '</p>'
        + '<p class="bill-createdAt">' + createdAt + '</p>'
        + '</div>'
        + amountHtml
        + '</div>'
      '</li>'
      return htmlString;
    },
    renderOrderList: function (result) {
      var that = this
      var billList = result.list
      pageNo = result.page
      maxPage = result.maxPage

      var listHtml = "";
      _.each(billList, function (bill) {
        listHtml += that.randerItem(bill)
      })
      $(".bill-list").append(listHtml)
    },
    showMore: function (){
      var that = this
      xqBridge.request({
        url: '/userbills/list.json',
        type: 'GET',
        data: {
          page: pageNo++
        },
        success: function (result) {
          that.renderOrderList(result);
        },
        error: function (e) {
          Util.showError(e)
        }
      })
    },
    loadMore: function() {
      var that = this
      if ($(window).scrollTop() + $(window).height() >= $(document).height()) {
        if (maxPage != pageNo) {
          that.showMore();
        }
      }
    }
  }
})