define(function (require, exports, module) {

  module.exports = {
    init: function () {
      xqBridge.showLoading();
      getWealth();
      this.showDetailBtn();
    },
    showDetailBtn: function () {
      xqBridge.setRightNavigationButton({
        title: "交易记录",
        action: function () {
          var bindUrl = "/wallet/snow-coin-bill";
          xqBridge.redirect({
            url: bindUrl,
            type: "PUSH"
          });
        }
      });
    }
  }

  // refresh snow_coin
  window.viewDidAppear = function () {
    getWealth();
  }

  function getWealth () {
    xqBridge.request({
      url: '/user/get_user_wealth.json',
      type: 'GET',
      success: function (ret) {
        xqBridge.hideLoading()
        $(".balance").text(parseInt(ret.user_wallet.snow_coin));
        $('body').data('snow_money', ret.snow_money);
      },
      error: function (e) {
        xqBridge.hideLoading()
        Util.showError(e);
      }
    })
  }

  Util.setPress("button", "active")
  $("button").on("click", function () {
    xqBridge.purchaseSnowCoin({
      url : 'https://xueqiu.com/c/deposit',
      type: 'MODAL',
      success: function (){
        getWealth();
      }
    })
  })
  $('a').on('click', function () {
    xqBridge.redirect({
      url: 'http://xueqiu.com/c/welfare',
      type: "PUSH"
    })
  })
})

