/**
 * Created by Edmond on 3/13/15.
 */
define(function (require, exports, module) {

  //var template = require('/path/to/use');

  //function clearThis(target){
  //  if (target.value === "请输入卡号") {
  //    target.value= "";
  //  }
  //}


  function tick(limitCount) {
    var id = setInterval(function () {
      limitCount--;
      if (limitCount == 0) {
        clearInterval(id);
        $('#verify').text('发送验证码');
        $('#verify').attr({
          "backgound": "#fd7722",
          "disabled": false
        });
      } else {
        $('#verify').text(limitCount + 's后重新获取');
      }
    }, 1000);
  };

  String.prototype.splice = function(start,length,replacement) {
    return this.substr(0,start)+replacement+this.substr(start+length);
  }
  String.prototype.repeat = function( num ) {
    return new Array( num + 1 ).join( this );
  }

  function confirmHandler(msg) {
    var length = msg.card_no.length - 8;
    var card_no = msg.card_no.splice(4, length, "*".repeat(length));
    xqBridge.confirm({
      title: '提现信息确认',
      message: '姓名: ' + msg.real_name + '\n' +
               '卡号: ' + card_no + '\n' +
               '金额: ' + msg.amount+ '元\n' +
               '手续费: 2元(雪球代付)',
      alignment: 'left',
      success: function () {
        xqBridge.request({
          url: '/tc/snowpay/withdraw/apply.json',
          type: 'POST',
          data: {
            verify_code: msg.verify_code,
            real_name: $('.name').val(),
            card_no: msg.card_no,
            amount: $('.cash-amount').val(),
            openBank: $('.default').text(),
          },
          success: function (ret) {
            if (ret.success == 0) {
              xqBridge.alert({
                message: ret.message
              });
            } else {
              xqBridge.redirect({
                url: '/wallet/state?state=1',
                type: 'PUSH'
              });
            }
          },
          error: function (e) {
            xqBridge.alert({
              message: e.error_description
            });
          }
        });
      },
      success_button: '确定',
      cancel_button: '取消'
    });
  }

  function errorHandler(e) {
    xqBridge.alert({
      message: '网络错误'
    });
  }

  /* 规则校验 */
  var Validator = function (rules) {
    this.rules = rules;
  };

  Validator.prototype.validateAll = function () {
    for (var name in rules) {
      if (!!rules[name].submitskip || !$('.' + name).length) {
        continue;
      }
      if (rules[name].rule() !== true) {

        Util.showError(rules[name].rule());
        return false;
      }
    }
    return true;
  };

  Validator.prototype.validate = function (rulename) {
    if (this.rules[rulename]) {
      return this.rules[rulename].rule();
    }
    return true;
  };

  var rules = {
    "name": {
      "rule": function () {
        var val = $('.name').val();
        if (!val) {
          return "姓名不能为空";
        } else if (!/^([\u4e00-\u9fa5]){2,7}$/.test(val)) {
          return "请输入合法姓名";
        }
        return true;
      }
    },
    "card-number": {
      "rule": function () {
        var val = $('.card-number').val();
        var data = $('.card-number').data('card_no');
        if (!data && !val) {
          return "请输入您的卡号";
        } else if (val != '' && !/[0-9]{4}[0-9]{8,11}[0-9]{4}/.test(val)){
          return "请输入正确位数的卡号";
        }
        return true;
      }
    },
    "default": {
      "rule": function () {
        var val = $('.default').text();
        if (val === '请选择银行') {
          return "请选择银行";
        }
        return true;
      }
    },
    "cash-amount": {
      "rule": function () {
        var val = $('.cash-amount').val();
        if (!val) {
          return "请输入提现金额";
        }else if (!/^[0-9]{0,10}(.[0-9]{1,2})?$/.test(val) || parseInt(val) <= 0) {
          return "请输入有效的提现金额";
        }
        return true;
      }
    },
    "verify-number": {
      "rule": function () {
        var val = $('.verify-number').val();
        if (!val) {
          return "验证码不能为空";
        } else if (!/[0-9]{4,6}/.test(val)) {
          return "请输入有效位数的验证码";
        }
        return true;
      }
    }
  };

  module.exports = {
    init: function () {
      this.getCashInfo();
    },

    getCashInfo: function () {
      xqBridge.request({
        url: '/tc/snowpay/withdraw/get_bind_info.json',
        type: 'GET',
        success: function (info) {
          if (info.real_name === '') {
            $('.name').prop("disabled", false);
          }else{
            $('.name').val(info.real_name);
          }

          if (info.card_no.length) {
            var length = info.card_no.length - 8;
            var card_no = info.card_no.splice(4, length, "*".repeat(length));
            $('.card-number').attr('placeholder', card_no);
            $('.card-number').data('card_no', info.card_no);
          }
          var params = Util.parseParams();
          $('#phone-number').append(params.number.splice(3, 4, "*".repeat(4)));
          if (params.snow_money.length) {
            $('.cash-amount').attr("placeholder", '可提现金额' + parseFloat(params.snow_money/100).toFixed(2) + '元');
          }
        },
        error: function (e) {
          errorHandler(e);
        }
      });
    }
  }
  $("select").on("change", function () {
    var text = $("select option:selected").text();
    $('.default').css('color', '#333');
    $(".default").text(text);
  });
  //$('#verify').on("touchstart", function() {
  //  $(this).css({background: "#fd7722"});
  //
  //}).on("touchend", function() {
  //  $(this).css({background: "#893f00"});
  //})

  $('#verify').on('click', function () {
    var $this = $(this);
    if (!$this.is(':disabled')) {
      var params = Util.parseParams();
      xqBridge.showLoading();
      xqBridge.request({
        url: "/account/sms/send_verification_code.json",
        type: "POST",
        data: {
          telephone: params.number
        },
        success: function () {
          Util.toast.show('获取验证码成功');
          $this.attr('disabled', true);
          tick(60);
        },
        error: function (err) {
          Util.toast.show(err.error_description);
          $this.attr('disabled', false);
          $('#verify').text('重新发送验证码');
        },
        complete: function () {
          xqBridge.hideLoading();
        }
      });
    }
  });

  Util.setPress("#withdraw-cash", "active");
  $('#withdraw-cash').on('click', function () {
    var verifyNumber = $('.verify-number').val();
    var validate = new Validator(rules);
    if (!validate.validateAll()){
      return;
    } else {
      var card_no = $('.card-number').val();
      card_no = card_no === '' ? $('.card-number').data('card_no') : card_no;
      confirmHandler({
        verify_code: verifyNumber,
        real_name: $('.name').val(),
        card_no: card_no,
        amount: $('.cash-amount').val()
      });
    }
  });
});